package test.web;

import java.io.IOException;
import javax.annotation.Resource;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.infinispan.Cache;
import org.infinispan.manager.CacheContainer;
import test.Foo;


@WebServlet(urlPatterns = {"/A"})
public class TestAServlet extends HttpServlet {

	private static final long serialVersionUID = -5601496447620989439L;

	@Resource(mappedName="java:jboss/infinispan/foo-cache") 
	private CacheContainer container;

	
	@Override
    public void init( ServletConfig config ) throws ServletException {}

    @Override
    public void destroy() {}

    @Override
    protected void doPost( HttpServletRequest request, HttpServletResponse response ) throws ServletException, IOException {
		Cache<?, ?> c = container.getCache( "foo" ).getAdvancedCache().with( Foo.class.getClassLoader() );
		Cache<String,Foo> cache = (Cache<String,Foo>) c;
    	//Cache<String,Foo> cache = container.getCache( "foo" );
    	String key = request.getParameter( "key" );
    	String text = request.getParameter( "text" );
    	Foo value = cache.get( key );
    	if ( value == null ) {
    		Foo newInstance = new Foo();
        	value = cache.putIfAbsent( key, newInstance );
        	if ( value == null ) {
        		value = newInstance;
        	}
    	} else {
    		request.getServletContext().log( "Updating existing FOO: classloader = " + value.getClass().getClassLoader() );
    	}
    	value.setText( text );
		request.getServletContext().log( "Cached FOO: " + key + " = " + text );
    }
}
