package test.web;

import java.io.IOException;
import javax.annotation.Resource;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.infinispan.Cache;
import org.infinispan.manager.CacheContainer;
import test.Foo;


@WebServlet(urlPatterns = {"/B"})
public class TestBServlet extends HttpServlet {

	private static final long serialVersionUID = -5601496447620989439L;

	@Resource(mappedName="java:jboss/infinispan/foo-cache") 
	private CacheContainer container;


	@Override
    public void init( ServletConfig config ) throws ServletException {}

    @Override
    public void destroy() {}

    @Override
    protected void doGet( HttpServletRequest request, HttpServletResponse response ) throws ServletException, IOException {
		Cache<?, ?> c = container.getCache( "foo" ).getAdvancedCache().with( Foo.class.getClassLoader() );
		Cache<String,Foo> cache = (Cache<String,Foo>) c;
    	//Cache<String,Foo> cache = container.getCache( "foo" );
    	String key = request.getParameter( "key" );
    	Object value = cache.get( key );
    	if ( value == null ) {
    		response.setStatus( 404 );
    	} else {
    		request.getServletContext().log( "Found cached entry for key: classloader = " + value.getClass().getClassLoader() );
    		response.getWriter().println( ((Foo) value).getText() );
    	}
    }
}
